        title   Calculator
; ___________________________________________________
;|                                                   |
;| GeneSys Calculator v1.0             Gene Brennick |
;| pbrennick@easycoder.org    http://www.pbrennick.com |
;|___________________________________________________|
;|                                                   |
;| A neat little calculator thingee that is a nice   |
;| tool for programmers and data gatherers.  There   |
;| are no bells and whistles as of yet but I will be |
;| combining this program with my Timer Utility and  |
;| some other things that are still in the dream     |
;| stage.  Certainly, the sum of the whole will be   |
;| greater than its parts...soon! A lot of thanks go |
;| out to Ewayne Wagner for all his help and also    |
;| for portions of the code.          Editor's note. |
;|___________________________________________________|
;|                                                   |
        .586           ; Select target CPU [Minimum] |
        .model  flat, stdcall  ; 32 bit memory model |
        option  casemap :none  ; Case Sensitive == 1 |
;|___________________________________________________|
;
        include \masm32\include\windows.inc
        include \masm32\include\user32.inc
        include \masm32\include\shell32.inc
        include \masm32\include\kernel32.inc
        include \masm32\include\gdi32.inc
        include \masm32\include\comctl32.inc
;
        includelib  \masm32\lib\user32.lib
        includelib  \masm32\lib\shell32.lib
        includelib  \masm32\lib\kernel32.lib
        includelib  \masm32\lib\gdi32.lib
        includelib  \masm32\lib\comctl32.lib
;
; Prototypes
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
wsprintfA           PROTO   C :DWORD, :VARARG
wsprintf            equ     <wsprintfA>
WinMain             PROTO   :DWORD, :DWORD, :DWORD, :DWORD
WinProc             PROTO   :DWORD, :DWORD, :DWORD, :DWORD
EditProc            PROTO   :DWORD, :DWORD, :DWORD, :DWORD
ToolbarProc         PROTO   :DWORD, :DWORD, :DWORD, :DWORD
CLRMW               PROTO   :DWORD, :DWORD
CopyMW              PROTO   :DWORD, :DWORD, :DWORD
CompMW              PROTO   :DWORD, :DWORD, :DWORD
MOVem               PROTO   :DWORD, :DWORD
AboutDlgProc        PROTO   hWnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
HyperLinkWndProc    PROTO   :DWORD, :DWORD, :DWORD, :DWORD
;
; Macros
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
MOVmd   MACRO   Var1, Var2
        push    Var2
        pop     Var1
        ENDM
;
.const
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
IDI_ICON1       equ 101
IDR_MENU1       equ 102
IDB_BUT07       equ 207
IDB_BUT08       equ 208
IDB_BUT09       equ 209
IDB_BUTADD      equ 218
IDB_BUTSQ       equ 223
IDB_BUT04       equ 204
IDB_BUT05       equ 205
IDB_BUT06       equ 206
IDB_BUTSUB      equ 219
IDB_BUTPCT      equ 224
IDB_BUT01       equ 201
IDB_BUT02       equ 202
IDB_BUT03       equ 203
IDB_BUTMUL      equ 220
IDB_BUTPOW      equ 225
IDB_BUT00       equ 200
IDB_BUTPER      equ 216
IDB_BUTEQ       equ 222
IDB_BUTDIV      equ 221
IDB_BUTPM       equ 217
IDB_BUTA        equ 210
IDB_BUTB        equ 211
IDB_BUTC        equ 212
IDB_BUTD        equ 213
IDB_BUTE        equ 214
IDB_BUTF        equ 215
IDB_BUTMC       equ 226
IDB_BUTMR       equ 227
IDB_BUTMS       equ 228
IDB_BUTMP       equ 229
IDB_BUTMM       equ 230
IDB_BUTHYP      equ 231
IDB_BUTREC      equ 232
IDB_BUTXN       equ 233
IDB_BUTPI       equ 234
IDB_BUTSIN      equ 235
IDB_BUTCOS      equ 236
IDB_BUTTAN      equ 237
IDB_BUTCSC      equ 238
IDB_BUTSEC      equ 239
IDB_BUTCOT      equ 240
IDB_BUTLOG      equ 241
IDB_BUT2X       equ 242
IDB_BUT10X      equ 243
IDB_BUTEX       equ 244
B1              equ 500
IDD_INFO        equ 1999
IDD_ABOUT       equ 2000
IDD_CALC        equ 2102
IDM_CLOSE       equ 6003
IDM_CUT         equ 6004
IDM_COPY        equ 6005
IDM_PASTE       equ 6006
IDM_INFO        equ 6026
IDM_ABOUT       equ 6027
IDT_TOOLBAR1    equ 301
IDT_TOOLBAR2    equ 302
IDT_TOOLBAR3    equ 303
IDT_TOOLBAR4    equ 304
IDT_TOOLBAR5    equ 305
IDC_URL         equ 9
IDC_EXIT        equ 3002
;
.data
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
FontName        db  'Courier New', 0
FontName1       db  'Times New Roman', 0
FmtA            db  '%lu', 0                ; Output as ascii string
FmtH            db  '%lX', 0                ; Output as hex UC
PLBuff          db  50 dup (?), 0
PRBuff          db  50 dup (?), 0
HLBuff          db  50 dup (?), 0
HRBuff          db  50 dup (?), 0
LBuff           db  50 dup (?), 0
RBuff           db  50 dup (?), 0
ConvH           db  120 dup (?), 0
ConvI           db  120 dup (?), 0
ConvO           db  120 dup (?), 0
Buff            db  120 dup (?), 0
Clear           db  50 dup (' '), 0
Zeros           db  64 dup ('0'), 0
AppName         db  '  GeneSys '               ; Do not separate this line from the next
class           db  'Calculator', 0
ErrorMsg        db  '** The output is out of range **            ', 0
szPaste         db  'Your Paste Selection Is Out Of'
                db  0Dh, 0Ah
                db  'Range For The Base Setting!', 0
TB              db  ' Calculator v1.0', 0
Info            db  38 dup (' ')
                db  'Most of the functions are self explanatory.'
                db  0Dh, 0Ah, 0Dh, 0Ah
                db  'There Are Three Two Step Functions.'
                db  0Dh, 0Ah
                db  '(1). X**n  Enter the base number click the X**n button enter the exponent click =.'
                db  0Dh, 0Ah
                db  '(2). HYP  Enter the X number click the HYP button enter the Y number click =.'
                db  0Dh, 0Ah
                db  '(3). %  Enter the first number click the X button enter the second number click %.'
                db  0Dh, 0Ah
                db  'Or Enter the first number click the +,-,x or div button enter the % number click % click =.', 0
EditPT          db  'EDIT', 0
Butt            db  'BUTTON', 0
Stat            db  'STATIC', 0
float           db  'Floating Point', 0
arc             db  'Arc', 0
BackS           db  'Back Space', 0
CE              db  'CE', 0
CLR             db  'C', 0
DegT            db  'Deg', 0
RadT            db  'Rad', 0
DecT            db  'Dec', 0
HexT            db  'Hex', 0
OctT            db  'Oct', 0
BinT            db  'Bin', 0
Pi              db  '3.141592653589793238', 0
Period          db  '.', 0
Zero            db  '0', 0
One             db  '1', 0
M               db  'M', 0
S               db  '-', 0
PO              db  '+', 0
SO              db  '-', 0
MO              db  'x', 0
DO              db  '/', 0
EO              db  '=', 0
Work            dd  0
CW              WORD    10
CWRound         WORD    037fh
CWNoRound       WORD    0f7fh
RNum10          REAL10  ?
RWrk10          REAL10  ?
RMem10          REAL10  ?
RDeg10          REAL10  0.01745329252
RRad10          REAL10  57.2957795130
Temp10          REAL10  ?
QW              dq  0
; DWORDS
;  1 - 4 Integers
;  5 - 8 Decimals
;  9 = Number of integers
; 10 = Number of decimals
; 11 = Number of leading zeroes
; 12 = Minus
A               dd  0, 0, 0, 0, 0, 0, 0, 0
B               dd  0, 0, 0, 0, 0, 0, 0, 0
D               dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
R               dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
R1              dd  0, 0, 0, 0
R2              dd  0, 0, 0, 0
R3              dd  0, 0, 0, 0
R4              dd  0, 0, 0, 0, 0, 0, 0, 0
R5              dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0
PT              dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
MEM             dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
Sav             dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
RH              dd  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0
BackGC          dd  00b1987ch
hInst           dd  0
hWnd            dd  0
hMenu           dd  0
hAccel          dd  0
hFont           dd  0
hDspF           dd  0
CommandLine     dd  0
hEdit           dd  0
hFloat          dd  0
hArc            dd  0
hMem            dd  0
hBkSp           dd  0
hOpr            dd  0
hCE             dd  0
hCLR            dd  0
hDeg            dd  0
hRad            dd  0
hDec            dd  0
hTB01           dd  0
hTB04           dd  0
hTB05           dd  0
SubEdit         dd  0
SubTool         dd  0
sedi            dd  0
sesi            dd  0
Float           dd  0
First           dd  0
sw1             dd  0
sw2             dd  0
sw3             dd  0
Min             dd  0
Key             dd  0
HPress          dd  0
NPress          dd  0
RPress          dd  0
BPress          dd  0
Branch          dd  0
Len             dd  0
HLen            dd  0
w1              dd  0
w2              dd  0
XP              dd  0
YP              dd  0
cnt             dd  0
ArcOn           dd  0
NoFix           dd  0
cpy             dd  0
Row             dd  0

Pos             dd  0
DecPos          dd  0
DP              dd  0
FPLZ            dd  0
PassDec         dd  0
I               dd  0
N               dd  0
T               dd  1
W               dd  0
Base            dd  10
HBase           dd  0
PrevBase        dd  0
StoreFlag       dd  0
SubZero         dd  0
AboutName       db  "AboutDialog", 0    ; About Box Name
szOpen          db  "open", 0           ; Action to perform
;
IDT             dd  IDT_TOOLBAR1,IDT_TOOLBAR2,IDT_TOOLBAR3,IDT_TOOLBAR4,IDT_TOOLBAR5
;
tb1     TBBUTTON    <0,IDB_BUTSIN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <1,IDB_BUTCOT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <2,IDB_BUTMC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <3,IDB_BUT07,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <4,IDB_BUT08,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <5,IDB_BUT09,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <6,IDB_BUTADD,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <7,IDB_BUTSQ,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbb1    TBBUTTON    <8,IDB_BUTHYP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl1    equ         ($-tbb1)
;
tb2     TBBUTTON    <0,IDB_BUTCOS,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <1,IDB_BUTLOG,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <2,IDB_BUTMR,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <3,IDB_BUT04,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <4,IDB_BUT05,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <5,IDB_BUT06,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <6,IDB_BUTSUB,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <7,IDB_BUTPCT,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbb2    TBBUTTON    <8,IDB_BUTREC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl2    equ         ($-tbb2)
;
tb3     TBBUTTON    <0,IDB_BUTTAN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <1,IDB_BUT2X,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <2,IDB_BUTMS,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <3,IDB_BUT01,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <4,IDB_BUT02,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <5,IDB_BUT03,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <6,IDB_BUTMUL,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <7,IDB_BUTPOW,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbb3    TBBUTTON    <8,IDB_BUTXN,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl3    equ         ($-tbb3)
;
tb4     TBBUTTON    <0,IDB_BUTCSC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <1,IDB_BUT10X,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <2,IDB_BUTMP,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <3,IDB_BUT00,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <4,IDB_BUTPER,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <5,IDB_BUTEQ,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <6,IDB_BUTDIV,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <7,IDB_BUTPM,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbb4    TBBUTTON    <8,IDB_BUTPI,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl4    equ         ($-tbb4)
;
tb5     TBBUTTON    <0,IDB_BUTSEC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <1,IDB_BUTEX,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <2,IDB_BUTMM,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <0,0,TBSTATE_ENABLED,TBSTYLE_SEP,0,0>
        TBBUTTON    <3,IDB_BUTA,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <4,IDB_BUTB,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <5,IDB_BUTC,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <6,IDB_BUTD,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
        TBBUTTON    <7,IDB_BUTE,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbb5    TBBUTTON    <8,IDB_BUTF,TBSTATE_ENABLED,TBSTYLE_BUTTON,0,0>
tbl5    equ         ($-tbb5)
;
tb      dd          tb1,tb2,tb3,tb4,tb5
tbl     dd          tbl1,tbl2,tbl3,tbl4,tbl5
;
.data?
;~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
hover       BOOL        ?
orgStatic   DD          ?
hFinger     DD          ?
buff        db          256 dup (?)
wc          WNDCLASS    <?>
msg         MSG         <?>
lf          LOGFONT     <?>
;
;
.code
;-------------------------------------------;
start:  call    InitCommonControls          ; Initialize the common ctrl lib
        invoke  GetModuleHandle, 0
        mov     hInst,eax                   ; hInstance is same as HMODULE
        invoke  GetCommandLine
        mov     CommandLine, eax
        invoke  WinMain, hInst, NULL, CommandLine, SW_SHOWDEFAULT
        invoke  ExitProcess, msg.wParam
;
;
; _________________________________________
;|                                         |
;|            WinMain Procedure            |
;|_________________________________________|
;
WinMain proc    hinst:DWORD, hPrevInst:DWORD, CmdLine:DWORD, CmdShow:DWORD
;-------------------------------------------
;       Initialize the WndClass structure and register the class name
        mov     wc.style, CS_HREDRAW or CS_VREDRAW or CS_GLOBALCLASS
        mov     wc.lpfnWndProc, offset WndProc
        mov     wc.cbClsExtra, 0
        mov     wc.cbWndExtra, 0
        mov     eax, hInst
        mov     wc.hInstance, eax
        invoke  LoadIcon, eax, IDI_ICON1
        mov     wc.hIcon, eax
        invoke  LoadCursor, 0, IDC_ARROW
        mov     wc.hCursor, eax
        mov     wc.hbrBackground, COLOR_BTNFACE+1
        mov     wc.lpszMenuName, 0
        mov     wc.lpszClassName, offset class
        invoke  RegisterClass, offset wc
        invoke  LoadMenu, hInst, IDR_MENU1
        mov     hMenu, eax
;
;       [Center the window]
        invoke  GetSystemMetrics, SM_CXSCREEN
        sub     eax, 238
        shr     eax, 1
        push    eax
        invoke  GetSystemMetrics, SM_CYSCREEN
        sub     eax, 270
        shr     eax, 1
        pop     ebx
;
;       [Create the Main Window]
        invoke  CreateWindowEx, 0, ADDR class, ADDR TB,
                WS_OVERLAPPED or WS_CAPTION or WS_SYSMENU or WS_MINIMIZEBOX,
                ebx, eax, 238, 270, NULL, hMenu, hinst, NULL
        mov     hWnd, eax
        invoke  ShowWindow, hWnd, SW_SHOWNORMAL
        invoke  UpdateWindow, hWnd
        invoke  SetWindowPos, hWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE or SWP_NOSIZE or SWP_SHOWWINDOW
        invoke  LoadAccelerators, hInst, 2007
        mov     hAccel, eax
BeginLoop:
        invoke  GetMessage, offset msg, 0, 0, 0
        cmp     eax, 0
        je      EndLoop
        invoke  TranslateAccelerator, hWnd, hAccel, offset msg
        cmp     eax, 0
        jne     BeginLoop
        invoke  TranslateMessage, offset msg
        invoke  DispatchMessage, offset msg
        jmp     BeginLoop
EndLoop:
        ret
;-------------------------------------------
WinMain endp
;
;
; _________________________________________
;|                                         |
;|            WinProc Procedure            |
;|_________________________________________|
;
WndProc proc    hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
;-------------------------------------------
        mov     eax, wmsg
        cmp     eax, WM_CREATE
        je      wmcreate
        cmp     eax, WM_COMMAND
        je      wmcommand
        cmp     eax, WM_CLOSE
        je      wmdestroy
        cmp     eax, WM_NOTIFY
        je      wmnotify
        cmp     eax, WM_INITMENUPOPUP
        je      wminitmenupopup
        .if wmsg == WM_KEYDOWN
          invoke  SetFocus, hEdit
        .endif
        jmp     defwndproc
wmcommand:
        mov     eax, wparam
        cwde                                ; Only low word contains command
        cmp     eax, IDM_CLOSE
        je      wmdestroy
        cmp     eax, IDM_CUT
        je      idmcut
        cmp     eax, IDM_COPY
        je      idmcopy
        cmp     eax, IDM_PASTE
        je      idmpaste
        cmp     eax, IDM_INFO
        je      idminfo
        cmp     eax, IDM_ABOUT
        je      idmabout
        cmp     eax, 1
        je      wmbs
        cmp     eax, 2
        je      wmce
        cmp     eax, 3
        je      wmclr
        .if eax == 19
          mov     T, 1
          invoke  SendMessage, hRad, BM_SETCHECK, BST_UNCHECKED, 0  ; Sets rad to unchecked
        .endif
        .if eax == 20
          mov     T, 2
          invoke  SendMessage, hDeg, BM_SETCHECK, BST_UNCHECKED, 0  ; Sets deg to unchecked
        .endif
;       21=Dec * 22=Hex * 23=Oct * 24=Bin
        and     sw2, 0
        .if eax == 21                       ; Dec
          .if Base != 10
            MOVmd   PrevBase, Base
            mov     Base, 10
            mov     sw2, 10
            call    DsplyConv
          .endif
        .endif
        .if eax == 22                       ; Hex
          .if Base != 16
            MOVmd   PrevBase, Base
            mov     Base, 16
            mov     sw2, 16
            call    DsplyConv
          .endif
        .endif
        .if eax == 23                       ; Oct
          .if Base != 8
            MOVmd   PrevBase, Base
            mov     Base, 8
            mov     sw2, 8
            call    DsplyConv
          .endif
        .endif
        .if eax == 24                       ; Bin
          .if Base != 2
            MOVmd   PrevBase, Base
            mov     Base, 2
            mov     sw2, 2
            call    DsplyConv
          .endif
        .endif
        .if eax > 20 && eax < 25
          and     I, 0
        .endif
        .if eax == 43
          and     Float, 0
          invoke  SendMessage, hFloat, BM_GETCHECK, 0, 0
          .if eax == 1
            or      Float, 1
          .endif
          jmp     wmclr
        .endif
        .if eax == 50
          and     ArcOn, 0
          invoke  SendMessage, hArc, BM_GETCHECK, 0, 0
          .if eax == 1
            or      ArcOn, 1
          .endif
        .endif
        jmp     defwndproc
wmcreate:
        invoke  GetSysColor, COLOR_MENU
        mov     BackGC, eax
        invoke  lstrcpy, ADDR lf.lfFaceName, ADDR FontName
        mov     lf.lfHeight, -12
        mov     lf.lfWeight, 500
        invoke  CreateFontIndirect, ADDR lf
        mov     hFont, eax
        invoke  lstrcpy, ADDR lf.lfFaceName, ADDR FontName1
        mov     lf.lfHeight, -12
        mov     lf.lfWeight, 500
        invoke  CreateFontIndirect, ADDR lf
        mov     hDspF, eax
        invoke  CreateWindowEx, NULL, ADDR Butt, ADDR float,
                WS_CHILD or WS_VISIBLE or BS_AUTOCHECKBOX,
                106, 54, 130, 12, hwnd, 43, hInst, NULL ; Floating Point
        mov     hFloat, eax
        invoke  SendMessage, hFloat, WM_SETFONT, hFont, 0
        invoke  CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditPT, NULL,
                WS_CHILD or WS_VISIBLE or WS_BORDER or ES_RIGHT or ES_AUTOHSCROLL or ES_SAVESEL,
                4, 0, 225, 22, hwnd, 44, hInst, NULL    ; Edit window
        mov     hEdit, eax
        invoke  SetWindowLong, hEdit, GWL_WNDPROC, EditProc
        mov     SubEdit, eax
        invoke  CreateWindowEx, NULL, ADDR Butt, ADDR arc,
                WS_CHILD or WS_VISIBLE or BS_AUTOCHECKBOX,
                8, 32, 40, 12, hwnd, 50, hInst, NULL    ; Arc for trig
        mov     hArc, eax
        invoke  SendMessage, hArc, WM_SETFONT, hFont, 0
        invoke  CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditPT, NULL,
                WS_CHILD or WS_VISIBLE or WS_BORDER or ES_CENTER or ES_READONLY,
                65, 26, 25, 21, hwnd, 88, hInst, NULL   ; Memory window
        mov     hMem, eax
        invoke  CreateWindowEx, NULL, ADDR Butt, ADDR BackS,
                WS_CHILD or WS_VISIBLE,
                104, 26, 80, 20, hwnd, 1, hInst, NULL   ; Backspace button
        mov     hBkSp, eax
        invoke  SendMessage, hBkSp, WM_SETFONT, hFont, 0
        invoke  CreateWindowEx, WS_EX_CLIENTEDGE, ADDR EditPT, NULL,
                WS_CHILD or WS_VISIBLE or WS_BORDER or ES_CENTER or ES_READONLY,
                203, 26, 25, 21, hwnd, 89, hInst, NULL  ; Operator window
        mov     hOpr, eax
        invoke  CreateWindowEx, NULL, ADDR Butt, ADDR CE,
                WS_CHILD or WS_VISIBLE,
                185, 73, 20, 20, hwnd, 2, hInst, NULL   ; Clear error button
        mov     hCE, eax
        invoke  SendMessage, hCE, WM_SETFONT, hFont, 0
        invoke  CreateWindowEx, NULL, ADDR Butt, ADDR CLR,
                WS_CHILD or WS_VISIBLE,
                205, 73, 20, 20, hwnd, 3, hInst, NULL   ; Clear button
        mov     hCLR, eax
        invoke  SendMessage, hCLR, WM_SETFONT, hFont, 0
;       Check boxes and radio buttons
        invoke  CreateWindowEx, NULL, ADDR Butt, 0,
                WS_CHILD or WS_VISIBLE or BS_GROUPBOX,
                4, 43, 89, 28, hwnd, 14, hInst, NULL    ; Deg & Rad group box
        invoke  CreateWindowEx, NULL, ADDR Butt, 0,
                WS_CHILD or WS_VISIBLE or BS_GROUPBOX,
                4, 65, 178, 28, hwnd, 15, hInst, NULL   ; Base group box
        xor     ebx, ebx
        mov     XP, 8
        mov     N, 19
BuildRadio:
        .if N < 21
          invoke  CreateWindowEx, NULL, ADDR Butt, ADDR DegT[ebx],
                  WS_CHILD or WS_VISIBLE or BS_AUTOCHECKBOX,
                  XP, 55, 39, 12, hwnd, N, hInst, NULL  ; Deg & Rad check boxes
          sub     XP, 3
        .else
          invoke  CreateWindowEx, NULL, ADDR Butt, ADDR DegT[ebx],
                  WS_CHILD or WS_VISIBLE or BS_AUTORADIOBUTTON,
                  XP, 77, 40, 12, hwnd, N, hInst, NULL  ; Base radio buttons
        .endif
        mov     hDeg[ebx], eax
        invoke  SendMessage, hDeg[ebx], WM_SETFONT, hFont, 0
        .if N < 24
          add     ebx, 4
          add     N, 1
          .if N == 21
            mov     XP, 8
          .else
            add     XP, 43
          .endif
          jmp     BuildRadio
        .endif
        invoke  SendMessage, hDeg, BM_SETCHECK, BST_CHECKED, 0  ; Sets deg to checked
        invoke  SendMessage, hDec, BM_SETCHECK, BST_CHECKED, 0  ; Sets dec to checked
;       Toolbars
        xor     ebx, ebx
        mov     XP, 4
        mov     YP, 94
        mov     Row, 0
        mov     I, 9
        mov     N, 11
        mov     W, 272
BuildTB:
        invoke  CreateWindowEx, NULL, ADDR Stat, 0,
                WS_CHILD or WS_VISIBLE,
                XP, YP, W, 24, hwnd, 1, hInst, NULL     ; Toolbars
        mov     hTB01, eax
        invoke  SetWindowLong, hTB01, GWL_WNDPROC, ToolbarProc
        mov     SubTool, eax
        invoke  CreateToolbarEx, hTB01, WS_CHILD or WS_VISIBLE or CCS_NODIVIDER,
                IDT[ebx], I, hInst, IDT[ebx], tb[ebx], N, 16, 16, 16, 16, tbl[ebx]
        .if Row < 4
          add     ebx, 4
          add     YP, 24
          add     Row, 1
          jmp     BuildTB
        .endif
        and     I, 0
wmnotify:
        jmp     returnP
wminitmenupopup:
        invoke  SendMessage, hEdit, EM_GETSEL, addr w1, addr w2
        mov     eax, w1
        .if w2 > eax
          invoke  EnableMenuItem, hMenu, IDM_CUT, MF_BYCOMMAND or MF_ENABLED
          invoke  EnableMenuItem, hMenu, IDM_COPY, MF_BYCOMMAND or MF_ENABLED
        .else
          invoke  EnableMenuItem, hMenu, IDM_CUT, MF_BYCOMMAND or MF_GRAYED
          invoke  EnableMenuItem, hMenu, IDM_COPY, MF_BYCOMMAND or MF_GRAYED
        .endif
        jmp     returnP
idmcut: invoke  SendMessage, hEdit, WM_CUT, 0, 0
        jmp     wmclr
idmcopy:
        invoke  SendMessage, hEdit, WM_COPY, 0, 0
        jmp     returnP
idmpaste:
        call    ClearValues
        invoke  SendMessage, hEdit, WM_PASTE, 0, 0
        jmp     returnP
idminfo:
        invoke  MessageBox, NULL, offset Info, offset AppName, MB_OK
        jmp     returnP
idmabout:
        invoke  CreateDialogParam, hInst, addr AboutName,
                hWnd, OFFSET AboutDlgProc, NULL
        jmp     returnP
wmbs:   invoke  SendMessage, hEdit, WM_GETTEXT, 35, ADDR Buff   ; Backspace
        invoke  lstrlen, ADDR Buff
        .if eax == 0
          jmp     returnP
        .endif
        .if eax == 2 && byte ptr Buff == '-'
          jmp     wmclr
        .endif
        invoke  lstrcpyn, ADDR ConvO, ADDR Buff, eax
        invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
        invoke  SendMessage, hEdit, EM_SETSEL, 33, 33
        invoke  SetFocus, hWnd
        invoke  lstrcpy, ADDR Buff, ADDR ConvO
        call    AsciiToBase
        invoke  lstrcpy, ADDR Buff, ADDR ConvO
        call    AsciiToFloat
        mov     edx, offset RNum10
        call    FloatToAscii
        jmp     returnP
wmce:   mov     ConvO, 0h                   ; Clear error
        invoke  SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
        invoke  SetFocus, hWnd
        jmp     returnP
wmclr:  call    ClearValues                 ; Clears all Fields
        jmp     returnP
defwndproc:
        invoke  DefWindowProc, hwnd, wmsg, wparam, lparam
        jmp     finish
wmdestroy:
        push    0
        call    PostQuitMessage             ; Quit
        jmp     returnP
returnP:
        xor     eax, eax
finish: ret
;-------------------------------------------
WndProc endp
;
;
; _________________________________________
;|                                         |
;|              Clear Values.              |
;|_________________________________________|
;
ClearValues     proc
;-------------------------------------------
        mov     ConvO, 0
        mov     ConvI, 0
        mov     Buff, 0
        mov     LBuff, 0
        mov     RBuff, 0
        mov     PLBuff, 0
        mov     PRBuff, 0
        and     HPress, 0
        and     NPress, 0
        and     RPress, 0
        and     BPress, 0                   ; 1=add, 2=sub, 3=mul, 4=div
        and     DP, 0
        invoke  SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
        invoke  SetFocus, hWnd
        invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR Clear
        mov     Len, 0
        invoke  CLRMW, offset R, 32
        and     First, 0
        fldz
        fstp    RNum10
        fldz
        fstp    RWrk10
        ret
;-------------------------------------------
ClearValues     endp
;
; _________________________________________
;|                                         |
;|        Processes keyboard input.        |
;|_________________________________________|
;
EditProc        proc hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
;-------------------------------------------
        mov     Key, 0
        .if wmsg == WM_KEYDOWN
          invoke  SendMessage, hEdit, EM_GETSEL, addr w1, addr w2
          mov     eax, w1
          .if w2 > eax && wparam != 17      ; CTRL key
            call    ClearValues
          .endif
        .endif
        .if wmsg == WM_PASTE
          call    ClearValues
          mov     Key, 288
          jmp     pass
        .endif
        .if wmsg == WM_CHAR
          .if wparam == 2bh
            mov     wmsg, WM_KEYUP
            mov     wparam, 6bh
          .endif
          .if wparam == 2ah
            mov     wmsg, WM_KEYUP
            mov     wparam, 6ah
          .endif
        .endif
        .if wmsg == WM_KEYUP
          invoke  SetFocus, hWnd
          invoke  SendMessage, hEdit, WM_GETTEXT, 35, ADDR Buff
          invoke  lstrlen, ADDR Buff
          .if eax > 16 && BPress == 3
            invoke  MessageBeep, MB_OK
            mov     Buff + 15, 0
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Buff
          .endif
          .if eax > 19 && BPress == 4 || eax > 19 && Float == 1
            invoke  MessageBeep, MB_OK
            mov     Buff + 18, 0
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Buff
          .endif
          .if wparam > 2fh && wparam < 3ah
            MOVmd   Key, wparam
            sub     Key, 48
            add     Key, 200
            jmp     pass
          .endif
          .if wparam > 5fh && wparam < 6ah
            MOVmd   Key, wparam
            sub     Key, 96
            add     Key, 200
            jmp     pass
          .endif
          .if wparam > 40h && wparam < 47h
            MOVmd   Key, wparam
            sub     Key, 55
            add     Key, 200
            jmp     pass
          .endif
          .if wparam == 6eh || wparam == 0beh
            mov     Key, 216                ; .
          .elseif wparam == 6bh             ;|| wparam == 0bbh
            mov     Key, 218                ; +
          .elseif wparam == 6dh || wparam == 0bdh
            mov     Key, 219                ; -
          .elseif wparam == 6ah || wparam == 0bah
            mov     Key, 220                ; *
          .elseif wparam == 6fh || wparam == 0bfh
            mov     Key, 221                ; /
          .elseif wparam == 0dh || wparam == 0bbh
            mov     Key, 222                ; =
          .else
          .endif
        .endif
pass:   invoke  CallWindowProc, SubEdit, hwnd, wmsg, wparam, lparam
        .if wmsg == WM_CUT
          call    ClearValues
        .endif
        .if Key > 0
          call    ToolbarProc
        .endif
        ret
;-------------------------------------------
EditProc        endp
;
;
; _________________________________________
;|                                         |
;|       Processes calculator input.       |
;|_________________________________________|
;
ToolbarProc     proc hwnd:DWORD, wmsg:DWORD, wparam:DWORD, lparam:DWORD
;-------------------------------------------
        .if wmsg == WM_COMMAND || Key > 0
          invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR Clear
          .if Key > 0
            MOVmd   wparam, Key
            mov     Key, 0
            invoke  SetFocus, hWnd
          .endif
          invoke  SendMessage, hEdit, WM_GETTEXT, 35, offset ConvO
          invoke  SendMessage, hEdit, WM_GETTEXT, 35, offset Buff
          .if Buff == '*'
            jmp     GetOut
          .endif
          mov     eax, wparam
          mov     N, 0
          .if eax == 288
            mov     ConvI, 0
            invoke  lstrlen, addr Buff
            mov     esi, eax
            xor     edi, edi
            mov     eax, '0'
            mov     ecx, '0'
            mov     edx, '0'
            .if Base == 10 || Base == 16
              mov     ebx, '9'
              .if Base == 16
                mov     ecx, 'A'
                mov     edx, 'F'
              .endif
            .elseif Base == 2
              mov     ebx, '1'
            .elseif Base == 8
              mov     ebx, '7'
            .endif
            .while (esi)
              .if byte ptr Buff[edi] > 90
                sub     byte ptr Buff[edi], 32
                sub     byte ptr ConvO[edi], 32
              .endif
              .if byte ptr Buff[edi] >= al && byte ptr Buff[edi] <= bl\
                  || byte ptr Buff[edi] >= cl && byte ptr Buff[edi] <= dl
              .else
                call    ClearValues
                invoke  MessageBox, NULL, addr szPaste, addr AppName, MB_OK or MB_ICONWARNING or MB_TASKMODAL
                jmp     GetOut
              .endif
              inc     edi
              dec     esi
            .endw
            jmp     DecP
          .endif
          .if Base == 10 || Base == 8       ; Dec or Oct
            or      N, 1
          .endif
          .if ((eax > 199 && eax < 210 && N == 1 || eax > 199 && eax < 216 && Base == 16)\
              || (eax > 199 && eax < 202 && Base == 2 || eax == 216))
            mov     eax, wparam
            sub     eax, 200
            .if eax == 16
              .if DP == 0
                mov     ConvI, '.'
                mov     ConvI+1, 0
              .else
                mov     ConvI, 0
              .endif
              jmp     DecP
            .endif
            lea     ebx, offset FmtA
            .if Base ==16
              lea     ebx, offset FmtH
            .endif
            invoke  wsprintf, ADDR ConvI, ebx, eax
DecP:       .if ConvO == '0' && ConvO + 1 == 0
              mov     ConvO, 0
            .endif
            invoke  lstrcat, offset ConvO, offset ConvI
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
            invoke  lstrlen, ADDR ConvO
            mov     ebx, 34
            .if Base == 16
              mov     ebx, 28
            .endif
            .if eax > ebx
              invoke  MessageBeep, MB_OK
              mov     ConvO[ebx], 0
              invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            .endif
            .if eax > 16 && BPress == 3
              invoke  MessageBeep, MB_OK
              mov     ConvO + 16, 0
              invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            .endif
            .if eax > 19 && BPress == 4 || eax > 19 && Float == 1
              invoke  MessageBeep, MB_OK
              mov     ConvO + 19, 0
              invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            .endif
            invoke  SendMessage, hEdit, EM_SETSEL, 34, 34
            invoke  lstrcpyn, ADDR Buff, ADDR ConvO, 34
            call    AsciiToBase
            invoke  lstrcpyn, ADDR Buff, ADDR ConvO, 34
            call    AsciiToFloat
            mov     edx, offset RNum10
            call    FloatToAscii
            mov     eax, wparam
          .endif
;         Memory clear
          .if eax == IDB_BUTMC
            and     StoreFlag, 0
            fldz
            fstp    RMem10
            invoke  CLRMW, offset MEM, 12
            invoke  SendMessage, hMem, WM_SETTEXT, NULL, ADDR Clear
          .endif
;         Memory recall
          .if eax == IDB_BUTMR
            .if BPress == 0
              fld     RMem10
              fstp    RNum10
              fld     RMem10
              fstp    RWrk10
            .else
              fld     RNum10
              fstp    RWrk10
              fld     RMem10
              fstp    RNum10
            .endif
            mov     edx, offset RNum10
            call    FloatToAscii
            MOVmd   MEM+40, SubZero
            invoke  CopyMW, offset R, offset MEM, 12
            call    BaseToAscii
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            invoke  SendMessage, hEdit, EM_SETSEL, 33, 33
          .endif
;         Memory store
          .if eax == IDB_BUTMS
StoreMem:   mov     StoreFlag, 1
            fld     RNum10
            fstp    RMem10
            invoke  CopyMW, offset MEM, offset R, 12
            invoke  SendMessage, hMem, WM_SETTEXT, NULL, ADDR M
            call    StoreCLR
            jmp     GetOut
          .endif
;         Memory add
          .if eax == IDB_BUTMP
            cmp     StoreFlag, 0
            je      StoreMem
            fld     RNum10
            fld     RMem10
            fadd    ST(0), ST(1)
            fstp    RMem10
            mov     edx, offset RMem10
            call    FloatToAscii
            invoke  CopyMW, offset PT, offset MEM, 12
            mov     BPress, 1
            call    Prep
            call    AddEM
            mov     BPress, 0
            invoke  CopyMW, offset MEM, offset R, 12
            invoke  SendMessage, hMem, WM_SETTEXT, NULL, ADDR M
            call    StoreCLR
          .endif
;         Memory subtract
          .if eax == IDB_BUTMM
            cmp     StoreFlag, 0
            je      StoreMem
            fld     RNum10
            fld     RMem10
            fsub    ST(0), ST(1)
            fstp    RMem10
            mov     edx, offset RMem10
            call    FloatToAscii
            invoke  CopyMW, offset PT, offset MEM, 12
            mov     BPress, 2
            call    Prep
            call    SubEM
            and     BPress, 0
            invoke  CopyMW, offset MEM, offset R, 12
            invoke  SendMessage, hMem, WM_SETTEXT, NULL, ADDR M
            call    StoreCLR
          .endif
;         Load pi
          .if eax == IDB_BUTPI
            fldpi
            fstp    RNum10
            mov     edx, offset RNum10
            call    FloatToAscii
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR Pi
            invoke  SendMessage, hEdit, EM_SETSEL, 33, 33
            invoke  lstrcpy, ADDR Buff, ADDR Pi
            call    AsciiToBase
          .endif
;         Trig functions
          .if eax == IDB_BUTSIN || eax == IDB_BUTCOS || eax == IDB_BUTTAN ||\
              eax == IDB_BUTSEC || eax == IDB_BUTCSC || eax == IDB_BUTCOT
            finit
            fld     RNum10
            .if T == 1
              fld     RDeg10
              fmul    ST(0), ST(1)
              .if eax == IDB_BUTTAN && ArcOn == 1
                fld     RNum10
              .endif
            .endif
            .if eax == IDB_BUTSIN
              .if ArcOn == 0
                fsin
              .else
                fld     st(0)               ; Duplicate X on tos.
                fmul                        ; Compute X**2.
                fld     st(0)               ; Duplicate X**2 on tos.
                fld1                        ; Compute 1-X**2.
                fsubr
                fdiv                        ; Compute X**2/(1-X**2).
                fsqrt                       ; Compute sqrt(x**2/(1-X**2)).
                fld1                        ; To compute full arctangent.
                fpatan                      ; Compute atan of the above.
              .endif
            .elseif eax == IDB_BUTCOS
              .if ArcOn == 0
                fcos
              .else
                fld     st(0)               ; Duplicate X on tos.
                fmul                        ; Compute X**2.
                fld     st(0)               ; Duplicate X**2 on tos.
                fld1                        ; Compute 1-X**2.
                fsubr
                fdivr                       ; Compute (1-x**2)/X**2.
                fsqrt                       ; Compute sqrt((1-X**2)/X**2).
                fld1                        ; To compute full arctangent.
                fpatan                      ; Compute atan of the above.
              .endif
            .elseif eax == IDB_BUTTAN && ArcOn == 0
              fptan
              fmul    ST(0), ST(1)
            .elseif eax == IDB_BUTTAN && ArcOn == 1
              fld1                          ; To compute full arctangent.
              fpatan                        ; Compute atan of the above.
              .if T == 1
                fld     RRad10
                fmul    ST(0), ST(1)
              .endif
            .elseif eax == IDB_BUTSEC
              .if ArcOn == 0
                fcos
                fld1
                fdivr
              .else
                fld     st(0)               ; Duplicate
                fmul                        ; Compute x*x
                fld1                        ; Load 1
                fsub                        ; Compute x*x-1
                fsqrt                       ; Compute sqrt(x*x-1)
                fld1                        ; Load 1
                fpatan                      ; Compute atan of above.
              .endif
            .elseif eax == IDB_BUTCSC
              .if ArcOn == 0
                fsin
                fld1
                fdivr
              .else
                fld     st(0)               ; Duplicate
                fmul                        ; Compute x*x
                fld1                        ; Load 1
                fsub                        ; Compute x*x-1
                fld1                        ; Load 1
                fdivr                       ; Compute 1/(x*x-1)
                fsqrt                       ; Compute sqrt(1/(x*x-1))
                fld1                        ; Load 1
                fpatan                      ; Compute atan of above.
              .endif
            .elseif eax == IDB_BUTCOT
              .if ArcOn == 0
                fsincos
                fdivr
              .else
                fld1                        ; fpatan computes
                fxch                        ; atan(st(1)/st(0)).
                fpatan                      ; atan(st(0)/st(1)).
              .endif
            .endif
            fstp    RNum10
            .if ArcOn == 0 || ArcOn == 1 && eax == IDB_BUTTAN
              or      NoFix, 1
            .endif
            mov     edx,offset RNum10
            call    FloatToAscii
            and     NoFix, 0
            jmp     FromSQ
          .endif
;         Log 10 function
          .if eax == IDB_BUTLOG && Buff != 0
            finit
            call    AsciiToFloat
            fld     RNum10
            fld1
            fxch
            fyl2x                           ; st(1) * log2(st(0)) 'alpha l not num 1'
            fldl2t
            fdiv
            fstp    RNum10
            mov     edx,offset RNum10
            call    FloatToAscii
            jmp     FromSQ
          .endif
;         Exponent functions
          .if eax == IDB_BUT2X || eax == IDB_BUT10X || eax == IDB_BUTEX && Buff != 0
            finit
            call    AsciiToFloat
            fld     RNum10
            .if eax == IDB_BUT2X
              call    TwoX
            .elseif eax == IDB_BUT10X
              call    TenX
            .elseif eax == IDB_BUTEX
              call    ExpX
            .endif
            mov     edx, offset RNum10
            call    FloatToAscii
            jmp     FromSQ
          .endif
;         Square root function
          .if eax == IDB_BUTSQ && Buff != 0
            finit
            call    AsciiToFloat
            fld     RNum10
            fsqrt
            fstp    RNum10
            mov     edx,offset RNum10
            call    FloatToAscii
            jmp     FromSQ
          .endif
;         Hypotenuse function
          .if eax == IDB_BUTHYP
            call    StoreCLR
            or      HPress, 1
            jmp     GetOut
          .endif
;         Pecentage function
          .if eax == IDB_BUTPCT
            push    BPress
            and     BPress, 0
            or      BPress, 3
            call    Prep
            invoke  CopyMW, offset RH, offset PT, 12
            invoke  lstrcpy, ADDR PLBuff, ADDR HLBuff
            invoke  lstrcpy, ADDR PRBuff, ADDR HRBuff
            call    MulEM
            call    BaseToAscii
            and     BPress, 0
            call    StoreCLR
            mov     dword ptr Buff, 0031302eh
            call    AsciiToBase
            call    BaseToAscii
            call    Prep
            or      BPress, 3
            call    MulEM
            call    BaseToAscii
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            invoke  SendMessage, hEdit, EM_SETSEL, 33, 33
            pop     BPress
            .if BPress > 0
              invoke  CopyMW, offset PT, offset RH, 12
              invoke  lstrcpy, ADDR HLBuff, ADDR PLBuff
              invoke  lstrcpy, ADDR HRBuff, ADDR PRBuff
              jmp     GetOut
            .endif
            jmp     GetOut
          .endif
;         X to the 2 power function
          .if eax == IDB_BUTPOW && Buff != 0
            .if Float == 0
              invoke  lstrcpy, offset HLBuff, offset LBuff
              invoke  lstrcpy, offset HRBuff, offset RBuff
              invoke  CopyMW, offset PT, offset R, 12
              .if PT+36 > 0 || R+36 > 0
                mov     BPress, 3
                call    ShiftDec
                jmp     EndIt
              .endif
              call    Prep
              call    MulMW
              invoke  CopyMW, offset R, offset R3, 4
              call    BaseToAscii
              jmp     EndIt
            .endif
            finit
            call    AsciiToFloat
            fld     RNum10
            fld     ST(0)
            fmulp   ST(1), ST(0)
            fstp    RNum10
            mov     edx,offset RNum10
            call    FloatToAscii
EndIt:      jmp     FromSQ
          .endif
;         X to the Nth power function
          .if eax == IDB_BUTXN
            call    StoreCLR
            or      NPress, 1
            jmp     GetOut
          .endif
;         Reciprocal of 1 function
          .if eax == IDB_BUTREC && Buff != 0
            mov     ConvH, 31h
            mov     HLBuff, 31h
            mov     HRBuff, 0
            mov     HLen, 0
            invoke  CLRMW, offset PT, 12
            mov     PT+12, 1
            mov     BPress, 4
            or      RPress, 1
            fld1
            fstp    RWrk10
            jmp     Continue
          .endif
;         Plus or Minus
          .if eax == IDB_BUTPM
            invoke  SendMessage, hEdit, WM_GETTEXT, 35, offset ConvO
            .if ConvO != 2dh
              mov     word ptr ConvI, 002dh
              invoke  lstrcat, ADDR ConvI, ADDR ConvO
            .else
              invoke  lstrcpy, ADDR ConvI, ADDR ConvO + 1
            .endif
            .if ConvI+1 != 0
              invoke  lstrcpy, ADDR Buff, ADDR ConvI
              call    AsciiToBase
              invoke  lstrcpy, ADDR Buff, ADDR ConvI
              call    AsciiToFloat
            .endif
            invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvI
          .endif
;         Addition function
          .if eax == IDB_BUTADD
            invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR PO
            call    StoreCLR
            mov     BPress, 1
            jmp     GetOut
          .endif
;         Subtraction function
          .if eax == IDB_BUTSUB
            invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR SO
            call    StoreCLR
            mov     BPress, 2
            jmp     GetOut
          .endif
;         Multiply function
          .if eax == IDB_BUTMUL
            invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR MO
            call    StoreCLR
            mov     BPress, 3
            jmp     GetOut
          .endif
;         Divide function
          .if eax == IDB_BUTDIV
            invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR DO
            call    StoreCLR
            mov     BPress, 4
            jmp     GetOut
          .endif
;         Equate function
          .if eax == IDB_BUTEQ
            invoke  SendMessage, hOpr, WM_SETTEXT, NULL, ADDR EO
Continue:   .if Float == 0                  ; Not floating point
              call    Prep
              .if BPress == 1
                call    AddEM
                jmp     FromSQ
              .elseif BPress == 2
                call    SubEM
                jmp     FromSQ
              .elseif BPress == 3
                call    MulEM
                jmp     FromSQ
              .elseif BPress == 4
                call    DivEM
                jmp     FromSQ
              .elseif NPress == 1
                .if PT+36 == 0 && R+36 == 0 ; No decimals
                  call    PowerN
                  jmp     FromSQ
                .else
                  jmp     FP
                .endif
              .elseif HPress == 1
                jmp     FP
              .else
                jmp     GetOut
              .endif
            .endif
FP:         finit
            fld     RNum10
            fld     RWrk10
            .if BPress == 1
              fadd    ST(0), ST(1)
            .elseif BPress == 2
              fsub    ST(0), ST(1)
            .elseif BPress == 3
              fmul    ST(0), ST(1)
            .elseif BPress == 4 && R+12 > 0 || BPress == 4 && R+28 > 0
              fdiv    ST(0), ST(1)
            .elseif NPress == 1
              fld1
              fxch
              fyl2x                         ; st(1) * log2(st(0)) 'alpha l not num 1'
              fmul
              call    TwoX
            .elseif HPress == 1
              fld     RWrk10
              fld     ST(0)                 ; Duplicate
              fmulP   ST(1), ST(0)
              fstp    RWrk10
              fld     RNum10
              fld     ST(0)                 ; Duplicate
              fmulp   ST(1), ST(0)
              fld     RWrk10
              fadd    ST(0), ST(1)
              fsqrt
            .endif
            fstp    RNum10
            fld     RNum10
            fstp    RWrk10
            mov     edx, offset RNum10
            call    FloatToAscii
FromSQ:     invoke  SendMessage, hEdit, WM_SETTEXT, NULL, ADDR ConvO
            invoke  SendMessage, hEdit, EM_SETSEL, 33, 33
            and     First, 0
            and     HPress, 0
            and     NPress, 0
            and     RPress, 0
            and     BPress, 0
            and     DP, 0
            invoke  SendMessage, hEdit, WM_GETTEXT, 34, offset Buff
            .if Buff == '*'
              mov     Buff, 0
            .endif
            call    AsciiToBase
            call    BaseToAscii
            invoke  SendMessage, hEdit, WM_GETTEXT, 34, offset Buff ; For floating point
            call    AsciiToBase
            fldz
            fstp    RWrk10
            fldz
            fstp    RNum10
            invoke  SendMessage, hEdit, WM_GETTEXT, 34, offset Buff ; For floating point
            call    AsciiToFloat
            and     Min, 0
          .endif
        .endif
GetOut: invoke  CallWindowProc, SubTool, hwnd, wmsg, wparam, lparam
        ret
;-------------------------------------------
ToolbarProc     endp
;
;
; _________________________________________
;|                                         |
;|       Setup for addition routine.       |
;|_________________________________________|
;
AddEM   proc
;-------------------------------------------
        .if Branch
          jmp     DoAdd
        .endif
        mov     eax, PT+44
        mov     ebx, R+44
        .if eax != ebx                      ; Signs not equal
          MOVmd   R5+32, PT+44
          and     BPress, 0
          or      BPress, 2
          or      Branch, 1
          call    SubEM
          jmp     Exit
        .endif
DoAdd:  call    AddMW
        call    BaseToAscii
        mov     eax, R+36
        .if eax > HLen
          mov     HLen, eax
        .endif
        invoke  lstrlen, offset RBuff
        .if eax > HLen && DecPos > 0
          call    Round
        .endif
        and     Branch, 0
Exit:   ret
;-------------------------------------------
AddEM   endp
;
;
; _________________________________________
;|                                         |
;|      Setup for subtraction routine      |
;|_________________________________________|
;
SubEM   proc
;-------------------------------------------
        .if Branch
          jmp     DoSub
        .endif
        mov     eax, PT+44
        mov     ebx, R+44
        .if eax != ebx                      ; Signs not equal
          MOVmd   R+44, R5+36
          or      Branch, 1
          call    AddEM
          jmp     Exit
        .endif
        .if R5+32 == 1
          and     R5+32, 0
        .else
          or      R5+32, 1
        .endif
DoSub:  mov     eax, R+36                   ; R+36 = length of dec num's cur
        .if eax > HLen                      ; HLen = length of dec num's prev
          mov     HLen, eax
        .endif
        invoke  lstrcmpi, offset HRBuff, offset RBuff
        .if eax == -1                       ; A < B
          call    Round
        .endif
        MOVmd   R+44, R5+32
        call    SubMW
        call    BaseToAscii
        invoke  lstrlen, offset RBuff
        .if HLen > eax && DecPos > 0
          invoke  lstrcpy, ADDR ConvO, ADDR LBuff
          invoke  lstrcat, ADDR ConvO, ADDR Period
          invoke  lstrcat, ADDR ConvO, ADDR Zero
          invoke  lstrcat, ADDR ConvO, ADDR RBuff
          invoke  lstrlen, offset LBuff+1
          invoke  lstrcpy, ADDR RBuff, ADDR ConvO[eax]  ; nonDecimal number
        .endif
        mov     BPress, 0
        and     Branch, 0
Exit:   ret
;-------------------------------------------
SubEM   endp
;
;
; _________________________________________
;|                                         |
;|       Setup for  multiply routine       |
;|_________________________________________|
;
MulEM   proc
;-------------------------------------------;
        .if PT+36 > 0 || R+36 > 0           ; Decimal numbers
          call    ShiftDec
          jmp     Exit
        .endif
        call    MulMW
        invoke  CopyMW, offset R, offset R3, 4
        mov     eax, PT+44
        mov     ebx, R+44
        and     R+44, 0
        .if eax != ebx                      ; Minus
          or      R+44, 1
        .endif
        call    BaseToAscii
Exit:   ret
;-------------------------------------------
MulEM   endp
;
;
; _________________________________________
;|                                         |
;|        Setup for divide routine.        |
;|_________________________________________|
;
DivEM   proc
;-------------------------------------------
        .if R > 0 || R+4 > 0 || R+4 > 0 || R+8 > 0 || R+24 > 0
          call    FPDivMW
          jmp     Exit
        .endif
        .if PT+36 > 0 || R+36 > 0
          call    ShiftDec
          jmp     Exit
        .endif
        call    DivMW
        invoke  CopyMW, offset R, offset R2, 4
        mov     eax, PT+44
        mov     ebx, R+44
        and     R+44, 0
        .if eax != ebx                      ; Minus
          or      R+44, 1
        .endif
        call    BaseToAscii
Exit:   ret
;-------------------------------------------
DivEM   endp
;
;
; _________________________________________
;|                                         |
;| Rounding or borrowing for decimal add   |
;| and subtract.                           |
;|_________________________________________|
;
Round   proc
;-------------------------------------------
        cmp     BPress, 2
        je      Subem
        invoke  lstrlen, ADDR LBuff
        add     eax, 2
        invoke  lstrcpyn, ADDR Buff, ADDR ConvI, eax
        invoke  lstrcat, ADDR Buff, ADDR RBuff + 1
        call    AsciiToBase
        .if HRBuff > '0'
          add     R+12, 1
        .endif
        call    BaseToAscii
        jmp     Done
Subem:  invoke  lstrcpy, ADDR Buff, ADDR HLBuff
        invoke  lstrcat, ADDR Buff, ADDR Period
        invoke  lstrcat, ADDR Buff, ADDR One
        invoke  lstrcat, ADDR Buff, ADDR HRBuff
        call    AsciiToBase
        sub     R+12, 1
        invoke  lstrcpy, ADDR Buff, ADDR LBuff
        invoke  lstrcat, ADDR Buff, ADDR Period
        invoke  lstrcat, ADDR Buff, ADDR Zero
        invoke  lstrcat, ADDR Buff, ADDR RBuff
        invoke  CopyMW, offset PT, offset R, 12
        call    AsciiToBase
        push    R5+32
        call    Prep
        pop     R5+32
Done:   ret
;-------------------------------------------
Round   endp
;
;
; _________________________________________
;|                                         |
;| Converts ascii string of Dec, Hex, Oct  |
;| or Bin to a 128 bit num value.          |
;|_________________________________________|
;
AsciiToBase     proc
;-------------------------------------------
        and     DP, 0
        and     Pos, 0
        and     cnt, 0
        invoke  CLRMW, offset R, 32
        invoke  lstrlen, ADDR Buff
        .if sw1 == 19 && eax > 19 && BPress == 3    ; Limit Multiplicand & Multiplier to 19
          mov     edx, offset Buff
          add     edx, 18
          .if byte ptr [edx]+1 >= 35h
            inc     byte ptr [edx]+0        ; + 1
          .endif
          mov     byte ptr [edx]+1, 0
          sub     eax, 19
          mov     Work, eax
        .endif
        invoke  lstrlen, ADDR Buff
        mov     ecx, offset Buff
        xor     edx, edx
        .while (eax)
          .if byte ptr [ecx] > 60h
            sub     byte ptr [ecx], 57h
            and     Pos, 0
          .elseif byte ptr [ecx] > 40h
            sub     byte ptr [ecx], 37h
            and     Pos, 0
          .elseif byte ptr [ecx] == 2eh
            or      Pos, 1
            or      cnt, 1
            or      DP, 1
;           Reduce decimal numbers to 19    ; 16
            push    eax
            push    ecx
            push    edx
            invoke  lstrlen, ADDR Buff
            pop     edx
            mov     ebx, offset Buff
            add     ebx, edx
            sub     eax, edx
            .if eax > 19
              .if byte ptr [ebx]+20 >= 35h
                inc     byte ptr [ebx]+19   ; +1
              .endif
              mov     byte ptr [ebx]+20, 0  ; Terminate string
            .endif
            pop     ecx
            pop     eax
          .elseif byte ptr [ecx] == 2dh
            or      R+44, 1                 ; Minus
          .else
            xor     byte ptr [ecx], 30h
            .if  byte ptr [ecx] == 0h && Pos == 1
              add     R+40, 1               ; Number of leading zeros after decimal
            .else
              and     Pos, 0
            .endif
          .endif
          inc     ecx
          inc     edx
          .if cnt == 0
            mov     R+32, edx               ; Number of whole numbers
          .endif
          cmp     edx, 32                   ; 64
          jnb     done
          dec     eax
        .endw
done:   .if edx == 0 || edx == 1 && R+44 == 1
          inc     edx
        .endif
        MOVmd   HBase, Base
        mov     edi, offset Buff              ; edi points to string to copy
        mov     R3+12, 1
        mov     R4+12, 1
        add     edi, edx
        dec     edi
        and     cnt, 0
        .if R+44 == 1
          dec     edx
          sub     R+32, 1
        .endif
Conv:   .if byte ptr[edi] == 2eh
          MOVmd   D+32, R+32                ; Number of whole numbers
          MOVmd   D+36, cnt                 ; Number of decimal numbers
          MOVmd   D+40, R+40                ; Number of leading zeros after decimal
          MOVmd   D+44, R+44                ; Minus
          invoke  CopyMW, offset D+16, offset R, 4
          invoke  CLRMW, offset R, 32
          invoke  CopyMW, offset R+16, offset D+16, 8
          mov     R3+12, 1
          mov     R4+12, 1
          jmp     PastDec
        .endif
        add     cnt, 1
        mov     al, byte ptr[edi]           ; Move byte edi points to into al
        and     eax, 000000ffh
        invoke  CLRMW, offset B, 4
        mov     B+12, eax
        invoke  CopyMW, offset A, offset R4, 4
        call    MulMW
        invoke  CopyMW, offset A, offset R, 4
        invoke  CopyMW, offset B, offset R3, 4
        or      PassDec, 1
        call    AddMW
        and     PassDec, 0
        invoke  CopyMW, offset A, offset R4, 4
        invoke  CLRMW, offset B, 4
        MOVmd   B+12, Base
        call    MulMW
        invoke  CopyMW, offset R4, offset R3, 4
PastDec:
        dec     edi
        dec     edx
        jnz     Conv
        ret
;-------------------------------------------
AsciiToBase     endp
;
;
; _________________________________________
;|                                         |
;| Converts a 128 bit num value to a Dec,  |
;| Hex, Oct or Bin ascii string.           |
;|_________________________________________|
;
BaseToAscii     proc
;-------------------------------------------
        mov     DecPos, 0
        push    Base
        push    esi
        push    edi
        .if sw2 != 0
          MOVmd   Base, sw2
        .endif
        mov     Pos, 0
        .if R+28 > 0
          invoke  CopyMW, offset A, offset R+16, 4
          mov     Pos, 1
        .else
          invoke  CopyMW, offset A, offset R, 4
        .endif
        MOVmd   B+12, Base
        xor     edi, edi
        xor     esi, esi
Loop1:  or      R5+24, 1
        call    DivMW
        and     R5+24, 0
        invoke  CopyMW, offset A, offset R2, 4
        .if dl > 9h
          add     dl,37h                    ; Convert to hex ASCII
        .else
          add     dl,30h                    ; Convert to dec ASCII
        .endif
        mov     Buff[esi], dl
        inc     edi
        .if A+12 > 0 || A+8 > 0 || A+4 > 0 || A > 0
          inc     esi
          jmp     Loop1
        .endif
        .if R+28 > 0 && Pos == 1            ; Decimal portion
          inc     esi
          mov     eax, R+40
          inc     eax
          push    edi
          push    esi
          invoke  lstrcpyn, ADDR Buff[esi], ADDR Zeros, eax ; Number of leading zeros after dec
          pop     esi
          pop     edi
          add     edi, R+40
          add     esi, R+40
          mov     byte ptr Buff[esi], 2eh
          mov     DecPos, esi
          inc     edi
          inc     esi
          invoke  CopyMW, offset A, offset R, 4
          mov     Pos, 0
          jmp     Loop1
        .endif
        xor     ecx, ecx
        .if R+44 == 1                       ; Minus
          mov     byte ptr ConvI, 2dh
          inc     ecx
        .endif
Loop2:  mov     al, byte ptr Buff[esi]
        mov     byte ptr ConvI[ecx], al
        inc     ecx
        dec     esi
        dec     edi
        jnz     Loop2
        mov     byte ptr ConvI[ecx], 0h
        mov     eax, Base
        .if eax == HBase
          mov     RBuff, 0h
          invoke  lstrlen, ADDR ConvI
          mov     esi, offset ConvI
          mov     edi, offset LBuff
Loop3:    .if byte ptr[esi] == 2eh
            mov     byte ptr[edi], 0h
            mov     edi, offset RBuff
            inc     esi
            dec     eax
            jz      AllDone
          .endif
          mov     bl, byte ptr[esi]
          mov     byte ptr[edi], bl
          inc     edi
          inc     esi
          dec     eax
          jnz     Loop3
          mov     byte ptr[edi], 0h
        .endif
        .if Base == 10 && !sw3
          MOVmd   SubZero, R+40
        .endif
AllDone:
        .if cpy != 8
          invoke  lstrcpy, ADDR ConvO, ADDR ConvI
        .endif
        pop     edi
        pop     esi
        pop     Base
        ret
;-------------------------------------------
BaseToAscii     endp
;
;
; _________________________________________
;|                                         |
;|         Clears multiple dwords.         |
;|_________________________________________|
;
CLRMW   proc    To:DWORD, Num:DWORD
;-------------------------------------------
        pushad
        xor     eax, eax
        mov     ebx, To
        mov     ecx, Num
Loop1:  mov     dword ptr[ebx+eax], 0
        add     eax, 4
        loop    Loop1
        popad
        ret
;-------------------------------------------
CLRMW   endp
;
;
; _________________________________________
;|                                         |
;|         Copies multiple dwords.         |
;|_________________________________________|
;
CopyMW  proc    To:DWORD, From:DWORD, Num:DWORD
;-------------------------------------------
        pushad
        xor     eax, eax
        mov     edx, To
        mov     ebx, From
        mov     ecx, Num
Loop1:  push    dword ptr[ebx+eax]
        pop     dword ptr[edx+eax]
        add     eax, 4
        loop    Loop1
        popad
        ret
;-------------------------------------------
CopyMW  endp
;
;
; _________________________________________
;|                                         |
;|        Compares multiple dwords.        |
;|_________________________________________|
;
CompMW  proc    Left:DWORD, Right:DWORD, Num:DWORD
;-------------------------------------------
        pushad
        xor     eax, eax
        mov     Work, 0
        mov     ebx, Left
        mov     edx, Right
        mov     ecx, Num
Loop1:  mov     esi, dword ptr[ebx+eax]
        .if esi > dword ptr[edx+eax]
          or      Work, 1                   ; A > B
          jmp     Done
        .endif
        .if esi < dword ptr[edx+eax]
          or      Work, 2                   ; A < B
          jmp     Done
        .endif
        push    dword ptr[ebx+eax]
        pop     dword ptr[edx+eax]
        add     eax, 4
        loop    Loop1
Done:   popad
        mov     eax, Work
        and     Work, 0
        ret
;-------------------------------------------
CompMW  endp
;
;
; _________________________________________
;|                                         |
;| Determines the decimal position and the |
;| number of leading zeros for multiply    |
;| and divide.                             |
;|_________________________________________|
;
ShiftDec        proc
;-------------------------------------------
        push    edi
        push    esi
        push    ebx
        mov     Sav, 0
        mov     Work, 0
        invoke  CLRMW, offset R5, 8
        MOVmd   R5, PT+36                   ; Decimal numbers dividend or Multiplicand
        MOVmd   R5+4, R+36                  ; Decimal numbers divisor or Multiplier
        MOVmd   R5+32, PT+44                ; Minus dividend or Multiplicand
        MOVmd   R5+36, R+44                 ; Minus divisor or Multiplier
        .if RBuff == 0h
          mov     R5+4, 0
        .endif
        mov     sw1, 19
        invoke  CLRMW, offset R, 32
        invoke  lstrcpy, offset Buff, offset HLBuff
        invoke  lstrcat, offset Buff, offset HRBuff
        call    AsciiToBase
        mov     eax, Work                   ; Work is built in AsciiToBase
        .if R5 >= eax
          sub     R5, eax                   ; Adjust the number of decimals
        .endif
        .if BPress == 4
          mov     R3+12, 1
          mov     ecx, R5+4
          .if R5 >= ecx
            sub     R5, ecx
            jmp     NoExtend
          .else
            sub     ecx, R5
            mov     R5, 0
          .endif
Extend:   invoke  CopyMW, offset A, offset R3, 4
          invoke  CLRMW, offset B, 4
          MOVmd   B+12, Base
          call    MulMW
          loop    Extend
          invoke  CopyMW, offset A, offset R, 4     ; Dividend
          invoke  CopyMW, offset B, offset R3, 4    ; Extend value
          call    MulMW
          invoke  CopyMW, offset R, offset R3, 4    ; Product
        .endif
NoExtend:
        mov     Work, 0
        invoke  CopyMW, offset PT, offset R, 12
        invoke  CLRMW, offset R, 32
        invoke  lstrcpy, offset Buff, offset LBuff
        invoke  lstrcat, offset Buff, offset RBuff
        call    AsciiToBase
        mov     eax, Work
        .if R5+4 >= eax
          sub     R5+4, eax                 ; Adjust the number of decimals
        .endif
        call    Prep
        .if BPress == 3
          call    MulMW
          invoke  CopyMW, offset R, offset R3, 4
        .elseif BPress == 4
          call    DivMW
          invoke  CopyMW, offset R, offset R2, 4
        .endif
        mov     eax, R5+32
        mov     ebx, R5+36
        and     R+44, 0
        .if eax != ebx                      ; Minus
          or      R+44, 1
        .endif
        call    BaseToAscii
        invoke  lstrlen, offset ConvI
        mov     ecx, eax
        mov     ebx, eax
        mov     edx, eax
        xor     esi, esi
        xor     edi, edi
        .if BPress == 3
          mov     ecx, R5
          add     ecx, R5+4
          sub     eax, R5
          sub     eax, R5+4
          mov     R5, ecx
        .elseif BPress == 4
FindDec:  mov     bl, byte ptr ConvI[esi]   ; Find decimal in Quotient
          .if bl == 2eh
            mov     ecx, esi
            inc     esi
            jmp     FindDec
          .endif
          inc     esi
          cmp     bl, 0h
          jne     FindDec
          mov     ebx, ecx                  ; Decimal position, length of Quotient whole number
          .if ecx >= R5
            sub     ecx, R5
          .else
            mov     ecx, R5
          .endif
          mov     eax, ecx
          sub     ecx, ebx
          inc     ecx
        .endif
        xor     esi, esi
        xor     edi, edi
        .if ebx >= R5                       ; No zero pad
          jmp     Loop1
        .endif
        .if BPress == 3
          sub     ecx, ebx
          inc     ecx
        .endif
        mov     byte ptr ConvO[edi], 2eh
        mov     Sav, edi
        add     edi, ecx
        push    edi
        push    esi
        invoke  lstrcpyn, offset ConvO+1, offset Zeros, ecx
        pop     esi
        pop     edi
        xor     eax, eax
Loop1:  mov     bl, byte ptr ConvI[esi]     ; Shift right
        .if bl == 2eh
          inc     esi
          jmp     Loop1
        .endif
        .if eax == edi
          mov     byte ptr ConvO[edi], 2eh
          mov     Sav, edi
          inc     edi
        .endif
        mov     byte ptr ConvO[edi], bl
        inc     edi
        inc     esi
        cmp     bl, 0h
        jne     Loop1
        mov     sw1, 0
        invoke  lstrcpy, offset Buff, offset ConvO
        call    AsciiToBase
        call    BaseToAscii
        mov     ebx, offset ConvO
        add     ebx, Sav
        call    Fixem
        pop     ebx
        pop     esi
        pop     edi
        ret
;-------------------------------------------
ShiftDec        endp
;
;
; _________________________________________
;|                                         |
;| Stores the current input and performs   |
;| the math functions for running totals.  |
;|_________________________________________|
;
StoreCLR        proc
;-------------------------------------------
        .if First == 0
          invoke  SendMessage, hEdit, WM_GETTEXT, 35, offset ConvH
CopyIt:   invoke  lstrcpy, offset HLBuff, offset LBuff
          invoke  lstrcpy, offset HRBuff, offset RBuff
          invoke  lstrlen, offset RBuff
          mov     HLen, eax
          invoke  CopyMW, offset PT, offset R, 12
          cmp     sw1, 3
          je      ClrDsply
          fld     RNum10
          fstp    RWrk10
          or      First, 1
        .endif
        .if Float == 0
          call    Prep
          .if BPress == 1
            call    AddEM
            and     BPress, 0
          .elseif BPress == 2
            call    SubEM
            and     BPress, 0
          .elseif BPress == 3
            call    MulEM
            and     BPress, 0
          .elseif BPress == 4 && Buff != 0
            call    DivEM
            and     BPress, 0
          .endif
          invoke  lstrcpy, offset Buff, offset ConvO
          call    AsciiToBase
          call    BaseToAscii
          invoke  lstrcpy, offset ConvH, offset ConvO
          or      sw1, 3
          jmp     CopyIt
        .endif
        finit
        fld     RNum10
        fld     RWrk10
        .if BPress == 1
          fadd    ST(0), ST(1)
          and     BPress, 0
        .elseif BPress == 2
          fsub    ST(0), ST(1)
          and     BPress, 0
        .elseif BPress == 3
          fmul    ST(0), ST(1)
          and     BPress, 0
        .elseif BPress == 4 && R+12 > 0 || BPress == 4 && R+28 > 0
          fdiv    ST(0), ST(1)
          and     BPress, 0
        .endif
        fstp    RWrk10
ClrDsply:
        mov     ConvO, 0
        invoke  SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
        and     sw1, 0
        and     DP, 0
        ret
;-------------------------------------------
StoreCLR        endp
;
;
; _________________________________________
;|                                         |
;| Adjusts the decimals numbers.  Prepares |
;| the input for the math functions.       |
;|_________________________________________|
;
Prep    proc
;-------------------------------------------
;       Sets the base power for the decimal number
        .if BPress == 1 || BPress == 2
          mov     R5+32, 1
          MOVmd   R5+36, PT+44
          invoke  CompMW, offset PT, offset R, 8
          .if eax == 2                      ; For add & sub flip A & B if B > A
            invoke  CopyMW, offset Sav, offset R, 12
            invoke  CopyMW, offset R, offset PT, 12
            invoke  CopyMW, offset PT, offset Sav, 12
            invoke  lstrcpy, offset ConvH, offset ConvO
            invoke  lstrcpy, offset HLBuff, offset LBuff
            invoke  lstrcpy, offset HRBuff, offset RBuff
            call    BaseToAscii
            invoke  lstrlen, offset HRBuff
            mov     HLen, eax
            mov     R5+32, 0
            MOVmd   R5+36, R+44
          .endif
        .endif
        .if PT+36 > 0 || R+36 > 0
          invoke  CLRMW, offset A, 16
          mov     A+12, 1
          MOVmd   B+12, HBase
          mov     eax, R+36
          .if PT+36 > eax
            mov     ecx, PT+36
            sub     ecx, eax
            jmp     LoopA
          .elseif PT+36 < eax
            mov     ecx, eax
            sub     ecx, PT+36
LoopA:      call    MulMW
            invoke  CopyMW, offset A, offset R3, 4
            loop    LoopA
            .if PT+36 < eax
              invoke  CopyMW, offset B, offset PT+16, 4
            .else
              invoke  CopyMW, offset B, offset R+16, 4
            .endif
            call    MulMW
            .if PT+36 < eax
              invoke  CopyMW, offset PT+16, offset R3, 4
            .else
              invoke  CopyMW, offset R+16, offset R3, 4
            .endif
          .endif
          .if BPress != 4
            mov     edx, R+40
            .if PT+40 > edx
            .else
              MOVmd   R+40, PT+40
            .endif
          .endif
        .endif
        invoke  CopyMW, offset A, offset PT, 8
        invoke  CopyMW, offset B, offset R, 8
        ret
;-------------------------------------------
Prep    endp
;
;
; _________________________________________
;|                                         |
;|          Adds multiple dwords.          |
;|_________________________________________|
;
AddMW   proc
;-------------------------------------------
        cmp     PassDec, 1
        je      Pass
        mov     eax, A+28
        add     eax, B+28
        mov     R+28, eax
        mov     eax, A+24
        adc     eax, B+24
        mov     R+24, eax
        mov     eax, A+20
        adc     eax, B+20
        mov     R+20, eax
        mov     eax, A+16
        adc     eax, B+16
        mov     R+16, eax
Pass:   mov     eax, A+12
        add     eax, B+12
        mov     R+12, eax
        mov     eax, A+8
        adc     eax, B+8
        mov     R+8, eax
        mov     eax, A+4
        adc     eax, B+4
        mov     R+4, eax
        mov     eax, A
        adc     eax, B
        mov     R, eax
        ret
;-------------------------------------------
AddMW   endp
;
;
; _________________________________________
;|                                         |
;|        Subtracts multiple dwords        |
;|_________________________________________|
;
SubMW   proc
;-------------------------------------------
        cmp     PassDec, 1
        je      Pass
        mov     eax, A+28
        sub     eax, B+28
        mov     R+28, eax
        mov     eax, A+24
        sbb     eax, B+24
        mov     R+24, eax
        mov     eax, A+20
        sbb     eax, B+20
        mov     R+20, eax
        mov     eax, A+16
        sbb     eax, B+16
        mov     R+16, eax
Pass:   mov     eax, A+12
        sub     eax, B+12
        mov     R+12, eax
        mov     eax, A+8
        sbb     eax, B+8
        mov     R+8, eax
        mov     eax, A+4
        sbb     eax, B+4
        mov     R+4, eax
        mov     eax, A
        sbb     eax, B
        mov     R, eax
        and     eax, 80000000h
        cmp     eax, 80000000h
        jnz     PlusNum
        invoke  CopyMW, offset A, offset B, 8
        invoke  CopyMW, offset B, offset PT, 8
        call    SubMW
PlusNum:
        ret
;-------------------------------------------
SubMW   endp
;
;
; _________________________________________
;|                                         |
;| Floating point divide used when the     |
;| divisor is greater then one dword.      |
;|_________________________________________|
;
FPDivMW proc
;-------------------------------------------
        finit
        fld     RNum10
        fld     RWrk10
        fdiv     ST(0), ST(1)
        fstp     RNum10
        fld     RNum10
        fstp     RWrk10
        mov     edx, offset RNum10
        .if !RPress
          or      NoFix, 1
        .endif
        call    FloatToAscii
        and     NoFix, 0
        ret
;-------------------------------------------
FPDivMW endp
;
;
; _________________________________________
;|                                         |
;|       Multiplies multiple dwords.       |
;|_________________________________________|
;
MulMW   proc
;-------------------------------------------
        pushad
;       Multiply B+12 dword of Multiplier times A+12 & A+8 & A+4 & A:
        mov     eax, B+12                   ;
        mov     ebx, eax                    ; Save Multiplier val
        mul     A+12                        ; Multiply L.O. dwords
        mov     R3+12, eax                  ; Save partial product
        mov     ecx, edx                    ; Save H.O. dword
        mov     eax, ebx                    ; Get Multiplier in ebx
        mul     A+8                         ; Multiply B+12 * A+8.
        add     eax, ecx                    ; Add partial product
        adc     edx, 0                      ; Don't forget carry!
        mov     ebx, eax                    ; Save partial product
        mov     ecx, edx                    ; For now.
        mov     eax, B+12                   ; Get Multiplier in B+12
        mul     A+4                         ; Multiply B+12 * A+4.
        add     eax, ecx                    ; Add partial product
        adc     edx, 0                      ; Don't forget carry!
        mov     w1, eax                     ; Save partial product
        mov     ecx, edx                    ; For now.
        mov     eax, B+12                   ; Get Multiplier in B+12
        mul     A                           ; Multiply B+12 * A.
        add     eax, ecx                    ; Add partial product
        adc     edx, 0                      ; Don't forget carry!
        mov     w2, eax                     ; Save partial product
        mov     ecx, 0                      ; For now.
;       Multiply B+8 dword of Multiplier times A+12 & A+8 & A+4 & A:
        mov     eax, B+8                    ; Get B+8. Multiplier
        mul     A+12                        ; Times A+12. dword
        add     eax, ebx                    ; Add partial product
        mov     R3+8, eax                   ; Save partial product
        adc     ecx, edx                    ; Add in carry/B+8!
        mov     eax, B+8                    ; Multiply the B+8.
        mul     A+8                         ; Words together.
        add     eax, ecx
        push     edx
        adc     edx, w2                     ; Works if B > A, Don't forget the carry!
        mov     ebx, edx
        pop     edx
        add     eax, w1                     ; Add partial product
        mov     R3+4, eax                   ; Save partial product
        adc     edx, w2                     ; Works if A > B    Don't forget carry!
        mov     R3,ebx
        .if w1 > ecx
          mov     R3, edx
        .endif
        popad
        ret
;-------------------------------------------
MulMW   endp
;
;
; _________________________________________
;|                                         |
;|        Divides multiple dwords.         |
;|_________________________________________|
;
DivMW   proc
;-------------------------------------------
        push     ecx
        .if B+12 == 00000000h
          jmp     DivRet
        .endif
        xor     edx, edx
        mov     eax, A                      ; Dividend
        div     B+12                        ; Divisor
        mov     R2, eax                     ; Quotient
        mov     eax, A+4
        div     B+12
        mov     R2+4, eax
        mov     eax, A+8
        div     B+12
        mov     R2+8, eax
        mov     eax, A+12
        div     B+12
        mov     R2+12, eax
        cmp     R5+24, 1
        je      DivRet                     ; From BaseToAscii no need to find decimals
        xor     ecx, ecx
        mov     HRBuff, 0h
        mov     eax, edx
Loop1:  .if edx > 0 && ecx < 19             ; 16, 12, 24
          inc     ecx
          mov     eax, edx
          mul     Base
          mov     Sav+8, edx
          mov     Sav+12, eax
          xor     edx, edx
          mov     eax, Sav+8
          div     B+12
          mov     eax, Sav+12
          div     B+12
          mov     sesi, ecx
          mov     sedi, edx
          push     eax
          .if Base == 16
            push     offset FmtH
          .else
            push     offset FmtA
          .endif
          push     offset ConvI
          call    wsprintfA
          add     esp, 12
          invoke  lstrcat, offset HRBuff, offset ConvI
          mov     edx, sedi
          mov     ecx, sesi
          jmp     Loop1
        .endif
        .if ecx > 0
          invoke  lstrcat, offset HRBuff, 0h
          mov     ebx, offset HRBuff
          call    Fixem
          mov     byte ptr Buff, 2eh
          invoke  lstrcpy, offset Buff+1, offset HRBuff
          invoke  CopyMW, offset PT, offset R2, 4
          call    AsciiToBase
          call    BaseToAscii
          invoke  CopyMW, offset R2, offset PT, 4
          .if sedi > 0
            add     R+28, 1
          .endif
        .endif
DivRet: pop      ecx
        ret
;-------------------------------------------
DivMW   endp
;
;
; _________________________________________
;|                                         |
;| Computes X to the Nth power integers    |
;| only.                                   |
;|_________________________________________|
;
PowerN  proc
;-------------------------------------------
        invoke  CLRMW, offset A, 16
        invoke  CLRMW, offset R+16, 4
        MOVmd   B+12, PT+12
        MOVmd   R3+12, 1
        mov     ecx, R+12
Power:  invoke  CopyMW, offset A, offset R3, 4
        call    MulMW
        loop    Power
        invoke  CopyMW, offset R, offset R3, 4
        call    BaseToAscii
        ret
;-------------------------------------------
PowerN  endp
;
;
; _________________________________________
;|                                         |
;|       Computes 2 to the Nth power       |
;|_________________________________________|
;
TwoX    proc
;-------------------------------------------
        fldcw   CWNoRound
        fld     st(0)                       ; Duplicate tos.
        fld     st(0)
        frndint                             ; Compute integer portion.
        fxch                                ; Swap whole and int values.
        fsub    st(0), st(1)                ; Compute fractional part.
        f2xm1                               ; Compute 2**frac(x)-1.
        fld1                                ; Load 1
        fadd                                ; Compute 2**frac(x).
        fxch                                ; Get integer portion.
        fld1                                ; Compute 1*2**int(x).
        fscale
        fstp    st(1)                       ; Remove st(1) (which is 1).
        fmul                                ; Compute 2**int(x) * 2**frac(x).
        fldcw   CWRound                     ; Restore rounding mode.
        fld     ST(0)
        fstp    RNum10
        ret
;-------------------------------------------
TwoX    endp
;
;
; _________________________________________
;|                                         |
;|      Computes 10 to the Nth power.      |
;|_________________________________________|
;
TenX    proc
;-------------------------------------------
        fldl2t                              ; Put lg(10) onto the stack
        fmul                                ; Compute x*lg(10)
        call    TwoX                        ; Compute 2**(x * lg(10)).
        ret
;-------------------------------------------
TenX    endp
;
;
; _________________________________________
;|                                         |
;|       Computes e to the Nth power       |
;|_________________________________________|
;
ExpX    proc
;-------------------------------------------;
        fldl2e                              ; Put lg(e) onto the stack.
        fmul                                ; Compute x*lg(e).
        call    TwoX                        ; Compute 2**(x * lg(e)).
        ret
;-------------------------------------------
ExpX    endp
;
;
; _________________________________________
;|                                         |
;| Rounds and removes excess zeros after   |
;| Mul, Div or floating point operations.  |
;|_________________________________________|
;
Fixem   proc
;-------------------------------------------
        mov     edx, ebx
        inc     edx
        push    ebx
        invoke  CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE, edx, 9, offset Zeros, 9
        pop     ebx
        .if eax == 2 && !RPress             ; 2 = match, so remove excess zeros
          mov     byte ptr [ebx], 0         ; Terminate string
        .endif
        cmp     Float, 1
        je      Pass
        mov     Pos, 0
        push    ebx
        invoke  lstrlen, ebx
        pop     ebx
        mov     ecx, eax
        xor     edx, edx
        .while (ecx)
          .if byte ptr [ebx] == 30h
            .if Pos == 0
              mov     edx, ebx
              or      Pos, 1
            .endif
          .else
            xor     edx, edx
          .endif
          inc     ebx
          dec     ecx
        .endw
        .if edx > 0
          mov     byte ptr [edx], 0         ; Terminate string
        .endif
Pass:   inc     ebx
        push    ebx
        invoke  lstrlen, ebx
        pop     ebx
        .if eax == 0
          jmp     Exit
        .endif
        mov     ecx, eax
        add     ebx, 1
        sub     ecx, 1
        mov     cnt, ebx
        add     cnt, 1                      ; '2' removes (7) 0's after ., '3' removes (8) 0's after .
        .while (ecx)
          push     ebx
          push     ecx
          invoke  CompareString, LOCALE_USER_DEFAULT, NORM_IGNORECASE, ebx, 9, offset Zeros, 9
          pop     ecx
          pop     ebx
          .if eax == 2 && ebx > cnt         ; 2 = match remove excess zeros
Again:      .if byte ptr [ebx]-1 == 30h
              dec     ebx
              jmp     Again
            .endif
            mov     byte ptr [ebx], 0       ; Terminate string
            .if byte ptr [ebx]-1 == 2eh
              mov     byte ptr [ebx]-1, 0   ; Terminate string
            .endif
            jmp     Exit
          .endif
          .if ((byte ptr [ebx]-1 != '9')\
              && (byte ptr [ebx]+0 == '9')\
              && (byte ptr [ebx]+1 == '9'))
            inc     byte ptr [ebx]-1        ; +1
            mov     byte ptr [ebx], 0       ; Terminate string
            .break                          ; Exit loop
          .endif
          dec     ecx                       ; Continue
          inc     ebx
        .endw
Exit:   ret
;-------------------------------------------
Fixem   endp
;
;
; _________________________________________
;|                                         |
;|       Used to convert the display       |
;|_________________________________________|
;
DsplyConv       proc
;-------------------------------------------
        .if Float == 0
          call    BaseToAscii
          jmp     NoDec
        .endif
        or      cpy, 8
        invoke  lstrcpy, offset Buff, offset PLBuff
        push    Base
        MOVmd   Base, PrevBase
        call    AsciiToBase
        pop     Base
        call    BaseToAscii
        invoke  lstrcpy, offset ConvO, offset ConvI
        .if I != 1
;         I = 1 comes from display, I = 0 comes from convert base
          invoke  lstrcpy, offset PLBuff, offset ConvI
        .endif
        invoke  lstrlen, offset PRBuff
        cmp     eax, 0
        je      NoDec
        invoke  lstrlen, offset ConvI
        invoke  lstrcat, offset ConvO, offset Period
        invoke  lstrcpy, offset Buff, offset PRBuff + 1
        push    Base
        MOVmd   Base, PrevBase
        call    AsciiToBase
        pop     Base
        call    BaseToAscii
        xor     ebx, ebx
LoopA:  .if byte ptr PRBuff[ebx+1] == 30h
;         Insert proper number of zeros after the decimal place
          invoke  lstrcat, offset ConvO, offset Zero
          inc     ebx
          jmp     LoopA
        .endif
        invoke  lstrcat, offset ConvO, offset ConvI
        .if I != 1
;         I = 1 comes from display, I = 0 comes from convert base
          invoke  lstrcpy, offset PRBuff, offset Period
          invoke  lstrcat, offset PRBuff, offset ConvI
        .endif
NoDec:  .if I != 1
;         I = 1 comes from display, I = 0 comes from convert base
          invoke  SendMessage, hEdit, WM_SETTEXT, NULL, offset ConvO
          invoke  SendMessage, hEdit, EM_SETSEL, 33, 33
          invoke  SetFocus, hWnd
        .endif
        and     sw2, 0
        and     cpy, 0
        ret
;-------------------------------------------
DsplyConv       endp
;
;
; _________________________________________
;|                                         |
;| Converts ascii string of Dec, Hex, Oct  |
;| or Bin to a REAL10 value.               |
;|_________________________________________|
;
AsciiToFloat    proc
;-------------------------------------------
        pushad
        and     Min, 0
        invoke  lstrlen, ADDR Buff          ; Input
        cmp     eax, 0
        je      GetOut
        xor     ecx, ecx
        mov     edx, offset Buff
        .while (eax)
          .if byte ptr [edx] > 60h
            sub     byte ptr [edx], 57h
          .elseif byte ptr [edx] > 40h
            sub     byte ptr [edx], 37h
          .elseif byte ptr [edx] == 2eh
            mov     byte ptr [edx], 2eh
          .elseif byte ptr [edx] == 2dh
            or      Min, 1
          .else
            sub     byte ptr [edx], 30h
          .endif
          inc     ecx
          inc     edx
          dec     eax
        .endw
        .if ecx == 0
          inc     ecx
        .endif
        mov     ebx, offset Buff            ; Ascii string
        mov     esi, ebx
        add     esi, ecx                    ; Set esi at the end of Buff
        dec     esi
        .if Min == 1
          dec     ecx
          inc     ebx
        .endif
        finit
        fldz                                ; Initialize ST(0) = 0
Loop1:  xor     eax, eax                    ; Set eax=0 for later
        mov     al, byte ptr[ebx]
        inc     ebx
        cmp     al, '.'
        je      Loop2                       ; Loop before the decimal point
        mov     Work, eax                   ; Set Work to number for loading
        fild    Base                        ; Load base for adding next digit
        fmulp   ST(1), ST                   ; ST(1)=ST(1)*ST & pop ST(0)
        fild    Work                        ; Load Work integer to ST(0)
        faddp   ST(1), ST                   ; ST(1)=ST(1)+ST & pop ST(0)
        loop    Loop1                       ; Next part of loop
        fldz                                ; Load a zero for decimal places
        jmp     NoMore                      ; No more characters
Loop2:  fldz                                ; Load another zero for the decimal portion
Loop3:  dec     ecx                         ; The actual loop after the decimal point
        jz      NoMore                      ; If out of characters or last one was a '.'
        mov     al, byte ptr[esi]           ; Get next character
        dec     esi                         ; Now esi is used for an index
        mov     Work,eax                    ; Store to Work
        fild    Work                        ; Load Work
        faddp   ST(1), ST                   ; Add new char to old value
        fild    Base                        ; Load base
        fdivp   ST(1), ST                   ; Divide by base to retain decimal
        jmp     Loop3
NoMore: faddp   ST(1), ST                   ; Add integer & decimal
        .if Min == 1
          fchs
        .endif
        fstp    tbyte ptr[RNum10]           ; Store real
GetOut: popad
        ret
;-------------------------------------------
AsciiToFloat    endp
;
;
; _________________________________________
;|                                         |
;| Converts a REAL10 value to a Dec, Hex,  |
;| Oct or Bin ascii string.                |
;|_________________________________________|
;
FloatToAscii    proc
;-------------------------------------------
        invoke  CopyMW, offset Sav, offset R, 12
        mov     PLBuff, 0
        mov     PRBuff, 0
        mov     esi, offset PRBuff
        mov     ebx,edx
        fldcw   CWNoRound
        fld     tbyte ptr[ebx]              ; Load number
        fst     Work
        and     Work, 80000000h
        cmp     Work, 80000000h
        jnz     PlusNum
        mov     Work, 1
        fchs                                ; Changes sign
PlusNum:
        fld     ST(0)                       ; Duplicate
        fistp   QW
        invoke  CLRMW, offset R, 32
        MOVmd   R+8, dword ptr QW+4
        MOVmd   R+12, dword ptr QW
        MOVmd   R+44, Work
        mov     sw3, 1
        call    BaseToAscii
        and     sw3, 0
        invoke  lstrcpy, ADDR PLBuff, ADDR ConvO
        fild    QW                          ; ST(0) : xxxxx,  ST(1) : xxxxx.yyyyy
        fsubp   ST(1), ST(0)                ; ST(0) = 0.yyyyy
        fst     Work
        cmp     Work, 0
        jz      Buildit                     ; No decimal
        invoke  lstrlen, ADDR PLBuff
        mov     byte ptr[esi], 2eh
        inc     esi
        mov     dx,sp                       ; Save stack pointer
        xor     ecx,ecx
        mov     edi,edx
CalcDec:
        fild    Base                        ; Base 10, 16, 8, 2
        fmulp   ST(1), ST(0)
        fld     ST(0)                       ; Duplicate
        call    Extend
        fist    Work                        ; Looks good at this point first int after dec
        fsubp   ST(1), ST(0)
        mov     eax, Work
        .if eax == 19999999h
          mov     ebx, esp
          jmp     GetOut
        .endif
        .if al > 9h
          add     al, 37h                   ; Convert to hex ASCII
        .else
          add     al, 30h                   ; Convert to dec ASCII
        .endif
        mov     byte ptr[esi], al           ; Ascii output
        inc     esi
        inc     ecx
        cmp     ecx, 19                     ;20, 12, 15
        jnz     CalcDec
        mov     ebx, esp
GetOut: mov     edx, edi
        mov     SP, DX                      ; Restore SP
        mov     byte ptr[esi], 0h
Buildit:
        invoke  lstrcpy, ADDR ConvO, ADDR PLBuff       ; Non decimal number
        invoke  lstrcat, ADDR ConvO, ADDR PRBuff       ; Decimal number
        fstp    Work                        ; Get rid of ST(0)
        cmp     PRBuff, 0
        je      Exit
        invoke  lstrlen, offset PLBuff
        .if eax > 18
          invoke  lstrcpy, ADDR ConvO, ADDR ErrorMsg    ; Error
          mov     PLBuff, 0
          mov     PRBuff, 0
          fldz
          fstp    RNum10
          jmp     Exit
        .endif
        mov     ebx, offset ConvO
        mov     edx, ebx
        add     ebx, eax
        .if RPress == 1
          push    edx
          invoke  lstrlen, offset ConvO
          pop     edx
          add     edx, eax
          .if byte ptr [edx]-1 != 39h
            inc     byte ptr [edx]-1        ; +1
          .endif
        .endif
        .if (!NoFix)
          call    Fixem
        .endif
        invoke  lstrlen, offset PLBuff
        mov     ebx, eax
        inc     ebx
        invoke  lstrcpyn, ADDR PLBuff, ADDR ConvO, ebx  ; nonDecimal number
        dec     ebx
        invoke  lstrcpy, ADDR PRBuff, ADDR ConvO[ebx]   ; Decimal number
Exit:   invoke  CopyMW, offset R, offset Sav, 12
        MOVmd   FPLZ, R+40
        ret
;-------------------------------------------
FloatToAscii    endp
;
;
Extend  proc
;-------------------------------------------;
        fild    Base                        ; Base 16, 10, 8, 2
        fmulp   ST(1), ST(0)
        fistp   w1
        mov     eax, w1
        xor     edx, edx
        div     Base                        ; Base 16, 10, 8, 2
        mov     w1, eax
        fild    w1
        ret
;-------------------------------------------
Extend  endp
;
;
HyperLinkWndProc proc HWnd  :DWORD,
                      uMsg  :DWORD,
                      wParam:DWORD,
                      lParam:DWORD
;---------------------------------------
        Local   tmpFont:LOGFONT
        Local   rect:RECT
        Local   pt:POINT
;
        mov     eax, uMsg
        .if eax==WM_NCHITTEST
          mov     eax, 1                ; We want to handle the non client hit test so we return true or 1
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          push    ebx
          push    edx
          invoke  SendMessage, HWnd, WM_GETFONT, 0, 0
          mov     edx, eax
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont
          mov     tmpFont.lfUnderline, TRUE
          invoke  CreateFontIndirect, addr tmpFont
          mov     ebx, eax
          invoke  SelectObject, wParam, ebx
          .if hover == FALSE
            invoke  SetTextColor, wParam, Blue
          .else
            invoke  SetTextColor, wParam, Red
          .endif
          invoke  GetSysColor, COLOR_MENU
          invoke  SetBkColor, wParam, eax
          invoke  DeleteObject, ebx
          invoke  GetStockObject, HOLLOW_BRUSH
          pop     edx
          pop     ebx
          ret
        .elseif eax==WM_MOUSEMOVE
          invoke  GetParent, HWnd
          push    ebx
          mov     ebx, eax
          invoke  GetActiveWindow
          .if eax == ebx
            invoke  GetCursorPos, addr pt
            invoke  GetWindowRect, HWnd, addr rect
            invoke  PtInRect, addr rect, pt.x, pt.y
            .if eax
              invoke  GetCapture
              .if !eax
                invoke  SetCapture, HWnd
                mov     hover, TRUE
                invoke  InvalidateRect, HWnd, FALSE, FALSE
                invoke  SetCursor, hFinger
              .endif
            .else
              invoke  GetCapture
              .if eax
                invoke  ReleaseCapture
                mov     hover, FALSE
                invoke  InvalidateRect, HWnd, FALSE, FALSE
              .endif
            .endif
          .endif
          pop     ebx
          xor     eax, eax
          ret
        .elseif eax==WM_LBUTTONDOWN
          invoke  GetWindowText, HWnd, offset buff, sizeof buff ; Change this for using a preset url
          invoke  ShellExecute, NULL, offset szOpen, offset buff, NULL, NULL, SW_MAXIMIZE   ; Change this to represent your preset url
          mov     hover, FALSE
          invoke  InvalidateRect, HWnd, FALSE, FALSE
          invoke  SendMessage, HWnd, WM_GETFONT, 0, 0           ; Get the defualt system font
          mov     edx, eax                                      ; Store result
          invoke  GetObject, edx, sizeof LOGFONT, addr tmpFont  ; Get our font into a logfont structure
          mov     tmpFont.lfUnderline, TRUE                     ; Under line the link
          invoke  CreateFontIndirect, addr tmpFont              ; Create the new font
          mov     ebx, eax                                      ; We need the return to free the memory later
          invoke  SelectObject, wParam, ebx                     ; Select our control
          invoke  SetTextColor, wParam, Blue                    ; Change this to change the color of the link
          xor     eax, eax                                      ; No errors
          ret                                                   ; Return
        .endif
        invoke  CallWindowProc, orgStatic, HWnd, uMsg, wParam, lParam   ;Passes message information to the next stop
        ret                                                 ; Return
;---------------------------------------
HyperLinkWndProc endp
;
;
AboutDlgProc proc hwnd:HWND, iMsg:DWORD, wParam:WPARAM, lParam:LPARAM
;---------------------------------------
        mov     eax, iMsg
        .if eax==WM_INITDIALOG
          invoke  GetDlgItem, hwnd, IDC_URL
          invoke  SetWindowLong, eax, GWL_WNDPROC, ADDR HyperLinkWndProc
          mov     orgStatic, eax
          mov     hFinger, eax
          xor     eax, eax
          ret
        .elseif eax == WM_CTLCOLORSTATIC
          invoke  SendMessage, lParam, iMsg, wParam, lParam
          ret
        .elseif eax==WM_CLOSE
          invoke  EndDialog, hwnd, NULL
        .elseif eax==WM_COMMAND
          push    edx
          mov     eax, wParam
          mov     edx, eax
          shr     edx, 16
          .if eax==IDC_EXIT
            invoke  SendMessage, hwnd, WM_CLOSE, NULL, NULL
            invoke  EndDialog, hwnd, NULL
          .endif
          pop     edx
        .else
          mov     eax, FALSE
          ret
        .endif
        mov      eax, TRUE
        ret
;---------------------------------------
AboutDlgProc endp


        end     start
